<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright &#352; 2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Infusion: MusicBox
| Version: 3.00 beta 7
| Author: Adam Gasowski (Gander)
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";

if (!checkrights("MB3") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../index.php"); }

if (file_exists(INFUSIONS."musicbox3_panel/locale/".$settings['locale'].".php")) {
	include INFUSIONS."musicbox3_panel/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."musicbox3_panel/locale/English.php";
}

define("FUSION_ASELF", FUSION_SELF.$aidlink);

require_once INFUSIONS."musicbox3_panel/infusion_db.php";
require_once INFUSIONS."musicbox3_panel/musicbox3_settings.php";
require_once INFUSIONS."musicbox3_panel/musicbox3_playlist.php";

if (file_exists(MB3_PLAYER_BASEDIR."index.php") && file_exists(MB3_PLAYER_BASEDIR."player.php")) {
	require_once MB3_PLAYER_BASEDIR."player.php";
	if (file_exists(MB3_PLAYER_BASEDIR.MB3_PLAYER_FILE)){
		if (MB3_PLAYLIST_FILE){
			if (file_exists(MB3_PLAYER_BASEDIR.".htaccess")){
				define("MB3_PLAYLIST_METHOD", "htaccess");
			} elseif (file_exists(MB3_PLAYER_BASEDIR.MB3_PLAYLIST_FILE)){
				if (is_writable(MB3_PLAYER_BASEDIR.MB3_PLAYLIST_FILE) || is_writable(MB3_PLAYER_BASEDIR)){
					define("MB3_PLAYLIST_METHOD", "file_dynamic");
				} else {
					define("MB3_PLAYLIST_METHOD", "file_static");
				}
			} else {
				define("MB3_PLAYLIST_METHOD", "file_not_exists");
			}
		} else {
			define("MB3_PLAYLIST_METHOD", "auto");
		}
		
		define("FUSION_ASELF_UPDATE", FUSION_ASELF.(MB3_PLAYLIST_METHOD=="file_dynamic"?"&action=write-dynamic-playlist":""));
		
		if (isset($_GET['track_id']) && !isNum($_GET['track_id'])) redirect(FUSION_ASELF);
		if (!isset($_GET['action'])) $_GET['action'] = "";
		
		if (isset($_POST['save'])){
			$track_artist = trim(stripinput($_POST['track_artist']));
			$track_title = trim(stripinput($_POST['track_title']));
			$track_path = trim(stripinput($_POST['track_path']));
			
			if (isset($_GET['track_id'])){
				dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_artist='".$track_artist."', track_title='".$track_title."', track_path='".$track_path."' WHERE track_id='".$_GET['track_id']."'");
			} else {
				dbquery("INSERT INTO ".DB_MB3_PLAYLIST." (track_artist, track_title, track_path, track_order) VALUES ('".$track_artist."', '".$track_title."', '".$track_path."', 999)");
			}
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if (isset($_POST['cancel'])){
			redirect(FUSION_ASELF);
		}
		
		if ($_GET['action'] == "sort-shuffle"){
			$result = dbquery("SELECT track_id FROM ".DB_MB3_PLAYLIST." ORDER BY RAND()");
			if (dbrows($result)){
				$order = 1;
				while ($data = dbarray($result)){
					dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_order='".($order++)."' WHERE track_id='".$data['track_id']."'");
				}
			}
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if ($_GET['action'] == "sort-refresh"){
			$result = dbquery("SELECT track_id FROM ".DB_MB3_PLAYLIST." ORDER BY track_order ASC, track_title ASC, track_id ASC");
			if (dbrows($result)){
				$order = 1;
				while ($data = dbarray($result)){
					dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_order='".($order++)."' WHERE track_id='".$data['track_id']."'");
				}
			}
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if ($_GET['action'] == "sort-by-title"){
			$result = dbquery("SELECT track_id FROM ".DB_MB3_PLAYLIST." ORDER BY track_title ASC, track_id ASC");
			if (dbrows($result)){
				$order = 1;
				while ($data = dbarray($result)){
					dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_order='".($order++)."' WHERE track_id='".$data['track_id']."'");
				}
			}
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if ($_GET['action'] == "sort-by-artist"){
			$result = dbquery("SELECT track_id FROM ".DB_MB3_PLAYLIST." ORDER BY track_artist ASC, track_title ASC, track_id ASC");
			if (dbrows($result)){
				$order = 1;
				while ($data = dbarray($result)){
					dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_order='".($order++)."' WHERE track_id='".$data['track_id']."'");
				}
			}
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if ($_GET['action'] == "sort-by-id"){
			$result = dbquery("SELECT track_id FROM ".DB_MB3_PLAYLIST." ORDER BY track_id ASC");
			if (dbrows($result)){
				$order = 1;
				while ($data = dbarray($result)){
					dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_order='".($order++)."' WHERE track_id='".$data['track_id']."'");
				}
			}
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if ($_GET['action'] == "sort-reverse"){
			$result = dbquery("SELECT track_id FROM ".DB_MB3_PLAYLIST." ORDER BY track_order DESC, track_id DESC");
			if (dbrows($result)){
				$order = 1;
				while ($data = dbarray($result)){
					dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_order='".($order++)."' WHERE track_id='".$data['track_id']."'");
				}
			}
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if ($_GET['action'] == "status-all-on"){
			dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_status='1'");
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if ($_GET['action'] == "status-all-off"){
			dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_status='0'");
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if ($_GET['action'] == "write-dynamic-playlist"){
			if (is_writable(MB3_PLAYER_BASEDIR.MB3_PLAYLIST_FILE) || is_writable(MB3_PLAYER_BASEDIR)){
				file_put_contents(MB3_PLAYER_BASEDIR.MB3_PLAYLIST_FILE, create_playlist_content());
			}
			redirect(FUSION_ASELF);
		}
		
		if ($_GET['action'] == "get-static-playlist"){
			redirect(MB3_PLAYER_BASEDIR."index.php?playlist");
		}

		
		if (isset($_POST['import'])) {
			$temp = $_FILES['playlist-file']['tmp_name'];
			if (strtolower(strrchr($_FILES['playlist-file']['name'], "."))!=".xml") {
				redirect(FUSION_ASELF);
			} elseif (is_uploaded_file($temp)){
				require_once "xml2array.php";
				$result = xml2array(file_get_contents($temp), 0);
				
				if (isset($result['playlist']['track']['title'])){
					$result['playlist']['track'] = array($result['playlist']['track']);
				}
				
				if (isset($result['playlist']['track']['0'])){
					foreach ($result['playlist']['track'] as $track){
						if (isset($track['artist'], $track['title'], $track['path'])){
							$track = array_map('stripinput', $track);
							$track = array_map('trim', $track);
							dbquery("INSERT INTO ".DB_MB3_PLAYLIST." (track_artist, track_title, track_path, track_order) VALUES ('".$track['artist']."', '".$track['title']."', '".$track['path']."', 999)");
						}
					}
					redirect(FUSION_ASELF."&action=sort-refresh");
				}
			}
		}
		
		if (isset($_POST['export'])) {
			$result = make_mb3_playlist(true);
			if (!isset($result[0])){
				$content = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
				$content .= "<playlist>\n";
				foreach ($result as $data){
					$content .= "<track>\n";
					$content .= "<artist>".$data['artist']."</artist>\n";
					$content .= "<title>".$data['title']."</title>\n";
					$content .= "<path>".$data['path']."</path>\n";
					$content .= "</track>\n";
				}
				$content .= "</playlist>\n";
				get_mb3_playlist($content, "playlist-export-".time().".xml");
			} else {
				redirect(FUSION_ASELF);
			}
		}
		
		if ($_GET['action'] == "delete" && isset($_GET['track_id'])){
			dbquery("DELETE FROM ".DB_MB3_PLAYLIST." WHERE track_id='".$_GET['track_id']."'");
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if ($_GET['action'] == "status" && isset($_GET['track_id'])){
			$result = dbquery("SELECT track_id, track_status FROM ".DB_MB3_PLAYLIST." WHERE track_id='".$_GET['track_id']."'");
			if (dbrows($result)){
				$data = dbarray($result);
				dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_status='".($data['track_status']?"0":"1")."' WHERE track_id='".$data['track_id']."'");
			}
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if ($_GET['action'] == "mup" && isset($_GET['track_id'])){
			$result = dbquery("SELECT track_id, track_order FROM ".DB_MB3_PLAYLIST." WHERE track_id='".$_GET['track_id']."'");
			if (dbrows($result)){
				$data1 = dbarray($result);
				$result = dbquery("SELECT track_id, track_order FROM ".DB_MB3_PLAYLIST." WHERE track_order<'".$data1['track_order']."' ORDER BY track_order DESC LIMIT 1");
				if (dbrows($result)){
					$data2 = dbarray($result);
					dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_order='".$data2['track_order']."' WHERE track_id='".$data1['track_id']."'");
					dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_order='".$data1['track_order']."' WHERE track_id='".$data2['track_id']."'");
				}
			}
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if ($_GET['action'] == "mdown" && isset($_GET['track_id'])){
			$result = dbquery("SELECT track_id, track_order FROM ".DB_MB3_PLAYLIST." WHERE track_id='".$_GET['track_id']."'");
			if (dbrows($result)){
				$data1 = dbarray($result);
				$result = dbquery("SELECT track_id, track_order FROM ".DB_MB3_PLAYLIST." WHERE track_order>'".$data1['track_order']."' ORDER BY track_order ASC LIMIT 1");
				if (dbrows($result)){
					$data2 = dbarray($result);
					dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_order='".$data2['track_order']."' WHERE track_id='".$data1['track_id']."'");
					dbquery("UPDATE ".DB_MB3_PLAYLIST." SET track_order='".$data1['track_order']."' WHERE track_id='".$data2['track_id']."'");
				}
			}
			redirect(FUSION_ASELF_UPDATE);
		}
		
		if ($_GET['action'] == "edit" && isset($_GET['track_id'])){
			$result = dbquery("SELECT * FROM ".DB_MB3_PLAYLIST." WHERE track_id='".$_GET['track_id']."'");
			if (!dbrows($result)) redirect(FUSION_ASELF);
			$data = dbarray($result);
			
			$track_artist = $data['track_artist'];
			$track_title = $data['track_title'];
			$track_path = $data['track_path'];
			
			$formaction = FUSION_ASELF."&amp;track_id=".$data['track_id'];
			$formcaption = "".$locale['mb3_001']." - ".$locale['mb3_002']."";
		} else {
			$track_artist = "";
			$track_title = "";
			$track_path = "";
			
			$formaction = FUSION_ASELF;
			$formcaption = "".$locale['mb3_001']." - ".$locale['mb3_003']."";
		}
		
		opentable($formcaption);
		echo "<form action='".$formaction."' method='post'>
	<table cellpadding='0' cellspacing='1' class='tbl-border' align='center'>
	<tr>
	<td class='tbl2'>".$locale['mb3_004']."</td>
	<td class='tbl2'><input type='text' name='track_artist' value='".$track_artist."' class='textbox' maxlength='50' size='20' /></td>
	</tr>
	<tr>
	<td class='tbl2'>".$locale['mb3_005']."</td>
	<td class='tbl2'><input type='text' name='track_title' value='".$track_title."' class='textbox' maxlength='100' size='35' /></td>
	</tr>
	<tr>
	<td class='tbl2'>".$locale['mb3_006']."</td>
	<td class='tbl2'><input type='text' name='track_path' value='".$track_path."' class='textbox' maxlength='255' size='60' /></td>
	</tr>
	<tr>
	<td class='tbl2' colspan='2' align='center'>
	<input type='submit' name='save' value='".$locale['mb3_007']."' class='button' />
	<input type='reset' value='".$locale['mb3_008']."' class='button' />
	<input type='submit' name='cancel' value='".$locale['mb3_009']."' class='button' />
	</td>
	</tr>
	</table>
	</form>\n";
		closetable();
		
		opentable("".$locale['mb3_001']." - ".$locale['mb3_010']."");
		$result = dbquery("SELECT * FROM ".DB_MB3_PLAYLIST." ORDER BY track_order ASC");
		if ($rows=dbrows($result)){

			if (file_exists("audio-player.js") && file_exists("player.swf")) {
				add_to_head("<script type='text/javascript' src='audio-player.js'></script>");
				add_to_head("<script type='text/javascript'>AudioPlayer.setup('player.swf', {width: 290, initialvolume: 80, transparentpagebg: 'yes', autostart: 'yes', titles: 'Playing...'});</script>");
				define("MP3TESTER", true);
			} else {
				define("MP3TESTER", false);
			}

			add_to_head("<script type='text/javascript' src='script.js'></script>");
			add_to_head("<script type='text/javascript'>function confirmDelete() {return confirm('".$locale['mb3_038']."');}</script>");
			
			echo "<div style='text-align:center; margin-bottom:5px;'>
	<form action='".FUSION_SELF."' method='get'>
	<input type='hidden' name='aid' value='".iAUTH."' />
	<select name='action' class='textbox' onChange='this.form.submit()'>
	<option value=''>".$locale['mb3_011']."</option>
	<optgroup label='".$locale['mb3_012']."'>
	<option value='sort-shuffle'>".$locale['mb3_013']."</option>
	<option value='sort-by-artist'>".$locale['mb3_014']."</option>
	<option value='sort-by-title'>".$locale['mb3_015']."</option>
	<option value='sort-by-id'>".$locale['mb3_016']."</option>
	<option value='sort-reverse'>".$locale['mb3_017']."</option>
	</optgroup>
	<optgroup label='".$locale['mb3_018']."'>
	<option value='status-all-on'>".$locale['mb3_019']."</option>
	<option value='status-all-off'>".$locale['mb3_020']."</option>
	</optgroup>\n";
		if (MB3_PLAYLIST_FILE){
			echo "<optgroup label='".$locale['mb3_021']."'>\n";
			if (MB3_PLAYLIST_METHOD=="file_dynamic") echo "<option value='write-dynamic-playlist'>".$locale['mb3_022']."</option>\n";
			echo "<option value='get-static-playlist'>".$locale['mb3_023']."</option>
	</optgroup>\n";
		}
		echo "</select>
	</form>
	</div><div id='mp3tester'></div>\n";
			
			$cnt = 0;
			echo "<table cellpadding='0' cellspacing='1' class='tbl-border' width='100%'>\n";
			echo "<tr>\n";
			echo "<td class='tbl2' align='center' colspan='2'><strong>#</strong></td>\n";
			echo "<td class='tbl2' align='center'><strong>".$locale['mb3_024']."</strong></td>\n";
			echo "<td class='tbl2' align='center'><strong>".$locale['mb3_025']."</strong></td>\n";
			echo "<td class='tbl2' align='center'><strong>".$locale['mb3_026']."</strong></td>\n";
			echo "<td class='tbl2' align='center' colspan='2'><strong>".$locale['mb3_027']."</strong></td>\n";
			echo "</tr>\n";
			while ($data = dbarray($result)){
				$cnt++;
				
				if ($cnt <> $data['track_order']) redirect(FUSION_ASELF."&action=sort-refresh");
				
				if ($rows > 1){
					if ($cnt==1){
						$order = "<a href='".FUSION_ASELF."&amp;action=mdown&amp;track_id=".$data['track_id']."'><img src='".get_image("down")."' alt='".$locale['mb3_028']."' title='".$locale['mb3_029']."' style='border:0px;' /></a>\n";
					} elseif ($cnt<$rows){
						$order = "<a href='".FUSION_ASELF."&amp;action=mdown&amp;track_id=".$data['track_id']."'><img src='".get_image("down")."' alt='".$locale['mb3_028']."' title='".$locale['mb3_029']."' style='border:0px;' /></a>\n";
						$order .= " <a href='".FUSION_ASELF."&amp;action=mup&amp;track_id=".$data['track_id']."'><img src='".get_image("up")."' alt='".$locale['mb3_030']."' title='".$locale['mb3_031']."' style='border:0px;' /></a>\n";
					} else {
						$order = "<a href='".FUSION_ASELF."&amp;action=mup&amp;track_id=".$data['track_id']."'><img src='".get_image("up")."' alt='".$locale['mb3_030']."' title='".$locale['mb3_031']."' style='border:0px;' /></a>\n";
					}
				} else {
					$order = "";
				}
				
				echo "<tr>\n";
				echo "<td class='tbl1' align='center' width='1%'>".$cnt."</td>\n";
				echo "<td class='tbl1' align='center' width='1%' nowrap='nowrap'>".($data['track_status']?"<img src='".IMAGES."tick.gif' alt='+' />":"")."</td>\n";
				echo "<td class='tbl1'><a href='".$data['track_path']."' target='_blank'".(MP3TESTER ? " onClick='return mp3tester(".$data['track_id'].", this.href)'" : "").">".$data['track_artist']." - ".$data['track_title']."</a><div id='mp3tester_".$data['track_id']."'><div id='audioplayer_".$data['track_id']."'></div></div></td>\n";
				echo "<td class='tbl1' align='center' width='1%' nowrap='nowrap'>".$order."</td>\n";
				echo "<td class='tbl1' align='center' width='1%' nowrap='nowrap'><a href='".FUSION_ASELF."&amp;action=status&amp;track_id=".$data['track_id']."'>".($data['track_status']?"".$locale['mb3_032']."":"".$locale['mb3_033']."")."</a></td>\n";
				echo "<td class='tbl1' align='center' width='1%' nowrap='nowrap'><a href='".FUSION_ASELF."&amp;action=edit&amp;track_id=".$data['track_id']."'>".$locale['mb3_034']."</a></td>\n";
				echo "<td class='tbl1' align='center' width='1%' nowrap='nowrap'><a href='".FUSION_ASELF."&amp;action=delete&amp;track_id=".$data['track_id']."' onClick='return confirmDelete()'>".$locale['mb3_035']."</a></td>\n";
				echo "</tr>\n";
			}
			echo "</table>\n";
		} else {
			echo "<div style='text-align:center'>".$locale['mb3_039']."</div>\n";
		}
		echo "<table cellpadding='0' cellspacing='1' width='100%'>
	<tr>\n";
		if ($rows) echo "<td class='tbl' align='left'>
	<form action='".FUSION_ASELF."' method='post'>
	<input type='submit' name='export' value='".$locale['mb3_036']."' class='button' />
	</form>
	</td>\n";
		echo "<td class='tbl' align='right'>
	<form action='".FUSION_ASELF."' method='post' enctype='multipart/form-data'>
	<input type='file' name='playlist-file' class='textbox' />
	<input type='submit' name='import' value='".$locale['mb3_037']."' class='button' />
	</form>
	</td>
	</tr>
	</table>\n";
		closetable();
		
		opentable("".$locale['mb3_001']." - ".$locale['mb3_040']."");
		echo "<table cellpadding='0' cellspacing='1' class='tbl-border' align='center'>
<tr>
<td class='tbl2'>".$locale['mb3_041']."</td>
<td class='tbl2'>".(defined("MB3_PLAYER_NAME") && MB3_PLAYER_NAME ? "<strong>".MB3_PLAYER_NAME."</strong>" : "<em>brak danych</em>")."</td>
<td class='tbl1' rowspan='4' width='100' align='center'><a href='".MB3_PLAYER_BASEDIR."' target='_blank' onClick='return startMusicBox3(this.href, ".MB3_PLAYER_WIDTH.", ".MB3_PLAYER_HEIGHT.")'><img src='play.gif' alt='Play' border='0' /></a></td>
</tr>
<tr>
<td class='tbl2'>".$locale['mb3_042']."</td>
<td class='tbl2'>".(defined("MB3_PLAYER_MAKER") && MB3_PLAYER_MAKER ? "<strong>".MB3_PLAYER_MAKER."</strong>" : "<em>brak danych</em>")."</td>
</tr>
<tr>
<td class='tbl2'>".$locale['mb3_043']."</td>
<td class='tbl2'>".(defined("MB3_PLAYER_WEB") && MB3_PLAYER_WEB ? "<a href='".MB3_PLAYER_WEB."' target='_blank'><strong>".trimlink(MB3_PLAYER_WEB, 50)."</strong></a>" : "<em>brak danych</em>")."</td>
</tr>
</table>\n";
		closetable();
		
		opentable("".$locale['mb3_001']." - ".$locale['mb3_044']."");
		switch (MB3_PLAYLIST_METHOD){
			case 'htaccess':
				printf ("<div>".$locale['mb3_045']."</div>\n", "<strong><em>.htaccess</em></strong>");
			break;
			case 'file_dynamic':
				printf ("<div>".$locale['mb3_046']."</div>\n", "<strong><em>".MB3_PLAYLIST_FILE."</em></strong>", "<em><strong>.htaccess</strong></em>");
			break;
			case 'file_static':
				printf ("<div>".$locale['mb3_047']."</div>\n", "<strong><em>".MB3_PLAYLIST_FILE."</em></strong>", "<em><strong>.htaccess</strong></em>");
			break;
			case 'file_not_exists':
				printf ("<div>".$locale['mb3_048']."</div>\n", "<strong><em>".MB3_PLAYLIST_FILE."</em></strong>", "<em><strong>ReadMe.html</strong></em>");
			break;
			case 'auto':
				printf ("<div>".$locale['mb3_049']."</div>\n");
			break;
		}
		closetable();
	} else {
		opentable("".$locale['mb3_001']." - ".$locale['mb3_050']."");
		printf ("<div style='text-align:center; font-size:14px; line-height:20px;'>".$locale['mb3_053']."</div>\n", "<em><strong>".MB3_PLAYER_FILE."</strong></em>", "<em><strong>".str_replace(BASEDIR, "", MB3_PLAYER_BASEDIR)."</strong></em>", "<em><strong>ReadMe.html</strong></em>");
		closetable();
	}		
} else {
	opentable("".$locale['mb3_001']." - ".$locale['mb3_050']."");
	printf ("<div style='text-align:center; font-size:14px; line-height:20px;'>".$locale['mb3_051']."</div>\n", "<em><strong>index.php</strong></em>", "<em><strong>player.php</strong></em>", "<em><strong>".str_replace(BASEDIR, "", MB3_PLAYER_BASEDIR)."</strong></em>", "<em><strong>ReadMe.html</strong></em>");
	closetable();
}

require_once THEMES."templates/footer.php";
?>